/*
* Copyright (c) 2012 Walmart. All rights reserved. Copyrights licensed under the New BSD License.
* See LICENSE file included with this code project for license terms.
*/


// Declare internals

var internals = {};


// Process configuration

exports.process = {

    name: 'Hapi Server',

    // Process Configuration

    process: {

        // runAs: 'www-data',
    },

    // Logging

    log: {

        levels: {

            info: true,
            err: true
        }
    },

    // Email Configuration

    email: {

        fromName: 'Hapi Server',
        replyTo: 'no-reply@localhost',
        admin: 'admin@localhost',

        server: {

            // port: 25,
            // user: '',
            // password: '',
            // host: 'localhost',
            // ssl: false
        }
    }
};


// Server configuration

exports.server = {

    uri: 'http://localhost:80',

    host: {                                 // Automatically set from 'uri'

        domain: 'localhost',
        scheme: 'http',
        port: '80',
        authority: 'localhost:80'
    },

    tls: {

        isOn: false,                        // Automatically set when TLS is initialized
        key: '',
        cert: ''
    },

    // Terms of Service

    tos: {

        min: '19700101'
    },

    // Authentication

    authentication: {

        loadSessionFunc: null,
        loadClientFunc: null,
        loadUserFunc: null,
        extensionFunc: null,
        loadGrantFunc: null,
        removeGrantFunc: null,

        defaultAlgorithm: 'hmac-sha-1',
        tokenLifetimeSec: 1209600,                  // Two weeks

        aes256Keys: {

            oauthRefresh: '',
            oauthToken: ''
        }
    },

    // Payload

    payload: {

        maxBytes: 1024 * 1024
    },

    // CORS

    cors: {

        maxAge: 86400                               // One day
    },

    // Extensions

    ext: {

        onPreRoute: function (req, res, next) { next(); },        // New request, before any middleware
        onPreHandler: function (req, res, next) { next(); },      // Before route handler is called, after validation
        onPostHandler: function (req, res, next) { next(); },     // After route handler returns, before setting response
        onPostRoute: function (req, res, next) { next(); }        // After response sent
    }
};


